﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace Scroller
{
 public partial class Page : UserControl
 {
  public Page()
  {
   InitializeComponent();
   pCsgImage = new Point(-200, -200);
  }
  bool bDeplEnCours=false;
  Point pPtPrec;
  Point pCsgImage; 

  void img_MouseLeftButtonDown(object sender, MouseEventArgs e)
  {
   double X = e.GetPosition(window).X;
   double Y = e.GetPosition(window).Y;
   pPtPrec = new Point(X, Y);
   bDeplEnCours = true;
  }

  void window_MouseLeave(object sender, EventArgs e)
  {
   bDeplEnCours = false;
  }

  private void img_MouseMove(object sender, MouseEventArgs e)
  {
   if (bDeplEnCours)
   {
    double X = e.GetPosition(window).X;
    double Y = e.GetPosition(window).Y;
    double deltaX = X - pPtPrec.X;
    double deltaY = Y - pPtPrec.Y;
    pPtPrec = new Point(X, Y);
    pCsgImage.X = Math.Min(pCsgImage.X + deltaX, 0);
    pCsgImage.X = Math.Max(pCsgImage.X, -(img.ActualWidth - window.Width));
    pCsgImage.Y = Math.Min(pCsgImage.Y + deltaY, 0);
    pCsgImage.Y = Math.Max(pCsgImage.Y, -(img.ActualHeight - window.Height));
    img.SetValue(Canvas.LeftProperty, pCsgImage.X);
    img.SetValue(Canvas.TopProperty, pCsgImage.Y);
   }
  }

  private void img_MouseLeftButtonUp(object sender, MouseButtonEventArgs e)
  {
   bDeplEnCours = false;
  }
 }
}
